VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Tile Info editor"
   ClientHeight    =   6135
   ClientLeft      =   2070
   ClientTop       =   1665
   ClientWidth     =   6120
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   409
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   408
   Begin VB.CommandButton cmdExport 
      Caption         =   "E&xport DAT"
      Height          =   375
      Left            =   4920
      TabIndex        =   19
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "&Load Tiles..."
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save..."
      Height          =   375
      Left            =   3720
      TabIndex        =   3
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "&Open..."
      Height          =   375
      Left            =   2520
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton cmdImport 
      Caption         =   "&Import..."
      Height          =   375
      Left            =   1320
      TabIndex        =   1
      Top             =   120
      Width           =   1095
   End
   Begin VB.Frame frmControls 
      BorderStyle     =   0  'None
      Enabled         =   0   'False
      Height          =   5655
      Left            =   0
      TabIndex        =   4
      Top             =   480
      Width           =   6015
      Begin VB.ComboBox lstEpisode 
         Height          =   315
         ItemData        =   "tileinfo.frx":0000
         Left            =   3960
         List            =   "tileinfo.frx":000D
         Style           =   2  'Dropdown List
         TabIndex        =   17
         Top             =   360
         Width           =   1935
      End
      Begin VB.ComboBox lstFrames 
         Height          =   315
         ItemData        =   "tileinfo.frx":001A
         Left            =   3960
         List            =   "tileinfo.frx":0027
         TabIndex        =   16
         Text            =   "lstFrames"
         Top             =   4680
         Width           =   1935
      End
      Begin VB.PictureBox picTiles 
         BackColor       =   &H80000005&
         FillStyle       =   0  'Solid
         Height          =   5415
         Left            =   120
         ScaleHeight     =   357
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   237
         TabIndex        =   11
         Top             =   120
         Width           =   3615
         Begin VB.VScrollBar scrTiles 
            Height          =   5355
            LargeChange     =   128
            Left            =   3300
            SmallChange     =   8
            TabIndex        =   15
            Top             =   0
            Width           =   255
         End
         Begin VB.Shape shpSelect 
            BorderColor     =   &H000000FF&
            BorderWidth     =   4
            FillColor       =   &H00404040&
            Height          =   315
            Left            =   1200
            Top             =   1200
            Visible         =   0   'False
            Width           =   315
         End
         Begin VB.Image imgTiles 
            Height          =   1215
            Left            =   0
            Top             =   0
            Width           =   975
         End
      End
      Begin VB.PictureBox picTile 
         BackColor       =   &H80000005&
         Height          =   1215
         Left            =   4320
         ScaleHeight     =   77
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   77
         TabIndex        =   10
         TabStop         =   0   'False
         Top             =   1920
         Width           =   1215
      End
      Begin VB.ComboBox lstTop 
         Height          =   315
         ItemData        =   "tileinfo.frx":004D
         Left            =   4320
         List            =   "tileinfo.frx":005D
         Style           =   2  'Dropdown List
         TabIndex        =   9
         Top             =   1560
         Width           =   1215
      End
      Begin VB.CheckBox chkLeft 
         Height          =   1215
         Left            =   3960
         Style           =   1  'Graphical
         TabIndex        =   8
         Top             =   1920
         Width           =   255
      End
      Begin VB.CheckBox chkRight 
         Height          =   1215
         Left            =   5640
         Style           =   1  'Graphical
         TabIndex        =   7
         Top             =   1920
         Width           =   255
      End
      Begin VB.CheckBox chkBottom 
         Height          =   255
         Left            =   4320
         Style           =   1  'Graphical
         TabIndex        =   6
         Top             =   3240
         Width           =   1215
      End
      Begin VB.ComboBox lstBehaviour 
         Height          =   315
         ItemData        =   "tileinfo.frx":0081
         Left            =   3960
         List            =   "tileinfo.frx":00E5
         Style           =   2  'Dropdown List
         TabIndex        =   5
         Top             =   3960
         Width           =   1935
      End
      Begin VB.Label lblTileNum 
         BackStyle       =   0  'Transparent
         Caption         =   "Current Tile: "
         Height          =   255
         Left            =   3960
         TabIndex        =   20
         Top             =   840
         Width           =   1935
      End
      Begin VB.Label lblEpisode 
         BackStyle       =   0  'Transparent
         Caption         =   "&Episode:"
         Height          =   255
         Left            =   3960
         TabIndex        =   18
         Top             =   120
         Width           =   1935
      End
      Begin VB.Label lblBlock 
         BackStyle       =   0  'Transparent
         Caption         =   "&Block behaviour:"
         Height          =   255
         Left            =   3960
         TabIndex        =   14
         Top             =   1200
         Width           =   1935
      End
      Begin VB.Label lblBehaviour 
         BackStyle       =   0  'Transparent
         Caption         =   "&General behaviour:"
         Height          =   255
         Left            =   3960
         TabIndex        =   13
         Top             =   3720
         Width           =   1935
      End
      Begin VB.Label lblAnimation 
         BackStyle       =   0  'Transparent
         Caption         =   "&Animation frames:"
         Height          =   255
         Left            =   3960
         TabIndex        =   12
         Top             =   4440
         Width           =   1335
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private SelectedTile As Integer
Private TilePicture As StdPicture
Private TilePictureFile As String
Private TileData(0 To 5, 0 To 800) As Integer
Private TileCount As Integer
Private Episode As Integer

Private Const TANIM = 0
Private Const TBEHAVE = 1
Private Const TTOP = 2
Private Const TRIGHT = 3
Private Const TBOTTOM = 4
Private Const TLEFT = 5

Private Type EXE_HEADER
    mzid As Integer
    image_l As Integer
    image_h As Integer
    num_relocs As Integer
    header_size As Integer
    min_paras As Integer
    max_paras As Integer
    init_ss As Integer
    init_sp As Integer
    checksum As Integer
    init_ip As Integer
    init_cs As Integer
    reloc_offset As Integer
    overlay_num As Integer
End Type
Private Const EXEMZ = &H5A4D
Private Const EXEZM = &H4D5A

Private Type BITMAPFILEHEADER
    bfType As String * 2 'BM
    bfSize As Long 'bytes
    bfReserved1 As Integer '0
    bfReserved2 As Integer '0
    bfOffBits As Long 'Offset in bytes to bit map
End Type '14
Private Type BITMAPINFOHEADER
    biSize As Long ' # bytes for this struct
    biWidth As Long 'Width of bitmap '
    biHeight As Long 'Height of bitmap: negative - top to bottom. Positive bottom to top '
    biPlanes As Integer ' #planes: 1 '
    biBitCount As Integer ' bits per pixel '
    biCompression As Long ' compression: should be BI!RGB '
    biSizeImage As Long ' size in bytes of image '
    biXPelsPerMeter As Long ' horz pels/metre '
    biYPelsPerMeter As Long ' vert pels/metre '
    biClrUsed  As Long '0
    biClrImportant As Long '0
End Type '40

Private Sub LoadBmp(Filename As String, BArray() As Byte)
    Dim n As Integer
    Dim bih As BITMAPINFOHEADER, bfh As BITMAPFILEHEADER
    Dim x As Integer, y As Integer, b As Byte
    
    n = FreeFile()
    Open Filename For Binary Access Read As #n
    Get #n, , bfh
    Get #n, , bih
    
    ReDim BArray(0 To bih.biWidth * bih.biHeight - 1)
    For y = 0 To bih.biHeight - 1
        Seek #n, bfh.bfOffBits + (bih.biHeight - y - 1) * (bih.biWidth * bih.biBitCount \ 8) + 1
        For x = 0 To (bih.biWidth \ 2) - 1
            Get #n, , b
            BArray(y * bih.biWidth + x * 2) = (b \ 16)
            BArray(y * bih.biWidth + x * 2 + 1) = (b And 15)
        Next
    Next
    Close #n
End Sub

Private Sub SetEpisode(e As Integer)
    Episode = e
    Select Case Episode
        Case 1
            TileCount = 611
            If lstEpisode.ListIndex <> 0 Then _
                lstEpisode.ListIndex = 0
        Case 2
            TileCount = 689
            If lstEpisode.ListIndex <> 1 Then _
                lstEpisode.ListIndex = 1
        Case 3
            TileCount = 715 'Only 624 tiles, but 715 entries
            If lstEpisode.ListIndex <> 2 Then _
                lstEpisode.ListIndex = 2
        Case Else
            SetEpisode 1
    End Select
End Sub

Private Sub chkBottom_Click()
    Dim n As Integer
    n = chkBottom.Value
    If TileData(TBOTTOM, SelectedTile) <> n Then _
        TileData(TBOTTOM, SelectedTile) = n
End Sub

Private Sub chkLeft_Click()
    Dim n As Integer
    n = chkLeft.Value
    If TileData(TLEFT, SelectedTile) <> n Then _
        TileData(TLEFT, SelectedTile) = n
End Sub

Private Sub chkRight_Click()
    Dim n As Integer
    n = chkRight.Value
    If TileData(TRIGHT, SelectedTile) <> n Then _
        TileData(TRIGHT, SelectedTile) = n
End Sub

Private Function GetExeVersion(ByVal FileNo As Integer, ByRef headerlen As Long) As Integer
    'Go to the start of the file
    Seek #FileNo, 1&


    Dim head As EXE_HEADER
    Dim imglen As Long

    Seek #FileNo, 1&
    'Read the header from the file if we can
    Get #1, , head
    'Check that the 'MZ' id is present
    If head.mzid = EXEMZ Or head.mzid = EXEZM Then
        'Calculate the image size
        imglen = (head.image_h - 1) * 512& + head.image_l - head.header_size * 16&
        headerlen = head.header_size * 16&
    Else
        headerlen = 0
        imglen = 0
    End If
    
    Select Case imglen
        Case 99762:  SetEpisode 1: GetExeVersion = 110
        Case 99972:  SetEpisode 1: GetExeVersion = 131
        Case 118114: SetEpisode 2: GetExeVersion = 100
        Case 118160: SetEpisode 2: GetExeVersion = 131
        Case 127086: SetEpisode 3: GetExeVersion = 100
        Case 127104: SetEpisode 3: GetExeVersion = 131
        Case Else: GetExeVersion = -1
    End Select
End Function


Private Sub cmdExport_Click()
    Dim Filename As String, FileTitle As String
    Dim BakName As String
    Dim Result As Boolean
    Dim Offsets(8) As Long, l As Long
    Dim i As Long, n As Integer, b As Byte
    Dim x As Integer, y As Integer, xt As Integer, yt As Integer
    Dim bmpBytes() As Byte
    
    Result = VBGetOpenFileName(Filename, FileTitle, True, False, False, True, _
        "KeenEdit DAT|keenedit.dat", 1, App.Path, "Export to KeenEdit DAT", _
        "dat", Me.hWnd, 0)
    
    If Result Then
        BakName = Left$(Filename, InStr(Filename, FileTitle) - 1) & "keenedit.~da"
        If Dir$(BakName) <> "" Then Kill BakName
        Name Filename As BakName
        Open BakName For Binary Access Read As #1
        Open Filename For Binary Access Write As #2
        For i = 0 To 7
            Get #1, , Offsets(i)
            Put #2, , Offsets(i)
        Next
       'Simple-minded copy
        ReDim bmpBytes(1 To Offsets(4 + Episode - 1) - Offsets(0)) As Byte
        Get #1, , bmpBytes()
        Put #2, , bmpBytes()
        
        'Put all the tiles in now
        Select Case Episode:
            Case 1: n = 611
            Case 2: n = 689
            Case 3: n = 624
        End Select
        l = n
        Put #2, , l
        
        LoadBmp TilePictureFile, bmpBytes
        For i = 0 To n - 1
            xt = i Mod 13
            yt = i \ 13
            
            b = 16
            Put #2, , b
            Put #2, , b
            'Put the bitmap data
            For y = 0 To 15
                For x = 0 To 15
                    b = bmpBytes((yt * 16& + y) * (13 * 16&) + (xt * 16& + x))
                    Put #2, , b
                Next
            Next
        Next
        'Write the remainder of the data
        Seek #1, Offsets(5 + Episode - 1) + 1
        ReDim bmpBytes(1 To LOF(1) - Offsets(5 + Episode - 1)) As Byte
        Get #1, , bmpBytes()
        Put #2, , bmpBytes()
    End If
    Close #1
    Close #2
End Sub

Private Sub cmdOpen_Click()
    Dim Filename As String, FileTitle As String
    Dim Result As Boolean
    Dim l As Long
    Dim i As Integer, j As Integer
    
    Result = VBGetOpenFileName(Filename, FileTitle, True, _
        False, False, True, "Tileinfo (*.tli)|*.tli", 1, _
        App.Path, "Open Tileinfo", "tli", Me.hWnd, 0)
        
    
    If Result Then
        Open Filename For Binary Access Read As #1
        l = LOF(1) \ 12
        Select Case l
            Case 611: SetEpisode 1
            Case 689: SetEpisode 2
            Case 715: SetEpisode 3
        End Select
        
        For i = 0 To 5
            For j = 0 To TileCount - 1
                Get #1, , TileData(i, j)
            Next
        Next
        Close #1
    End If
    SelectTile 0
End Sub

Private Sub Form_Load()
    SetEpisode 1
End Sub

Private Sub lstEpisode_Click()
    SetEpisode lstEpisode.ListIndex + 1
End Sub

Private Sub lstFrames_Click()
    Dim n As Integer
    Select Case lstFrames.ListIndex
        Case 0:
            n = 1
        Case 1:
            n = 2
        Case 2:
            n = 4
        Case Else:
            n = 1
    End Select
    If TileData(TANIM, SelectedTile) <> n Then
        TileData(TANIM, SelectedTile) = n
    End If
End Sub

Private Sub cmdImport_Click()
    Dim Filename As String, FileTitle As String
    Dim Result As Boolean
    Dim ver As Integer
    Dim Offset As Long, HeaderSize As Long
    Dim i As Integer, j As Integer
    
    Result = VBGetOpenFileName(Filename, FileTitle, True, False, False, True, _
        "Exe files|*.exe", 1, App.Path, "Import from EXE", "exe", Me.hWnd, 0)
        
    If Result Then
        Open Filename For Binary Access Read As #1
        ver = GetExeVersion(1, HeaderSize)
        If ver = -1 Then
            MsgBox "Can't recognise this exe! Did you forget to UNLZEXE it?"
            Exit Sub
        End If
        
        If Episode = 1 Then
            If ver = 110 Then Offset = &H131F8
            If ver = 131 Then Offset = &H130F8
        ElseIf Episode = 2 Then
            If ver = 100 Then Offset = &H17938
            If ver = 131 Then Offset = &H17828
        ElseIf Episode = 3 Then
            If ver = 100 Then Offset = &H199F8
            If ver = 131 Then Offset = &H198C8
        End If
        
        Seek #1, Offset + HeaderSize + 1
    
        For i = 0 To 5
            For j = 0 To TileCount - 1
                Get #1, , TileData(i, j)
            Next
        Next
        Close #1
        SelectTile 0
    End If
End Sub

Private Sub cmdLoad_Click()
    Dim TileFile As String, FileTitle As String
    Dim Result As Boolean
    
    Result = VBGetOpenFileName(TileFile, FileTitle, True, False, False, True, _
        "Bitmaps (*.bmp)| *.bmp", 1, App.Path, "Load Tiles", "bmp", Me.hWnd, 0)
        
    If Result Then
        Set TilePicture = LoadPicture(TileFile)
        TilePictureFile = TileFile
        Set imgTiles.Picture = TilePicture
        SetScrollbar
        frmControls.Enabled = True
    End If
    
    SelectTile 0
End Sub
Sub SetScrollbar()
    imgTiles.TOp = 0
    If imgTiles.Height > picTiles.ScaleHeight Then
        scrTiles.Min = 0
        scrTiles.Max = imgTiles.Height - picTiles.ScaleHeight
        scrTiles.Enabled = True
    Else
        scrTiles.Enabled = False
    End If
    SelectTile 0
End Sub


Private Sub cmdSave_Click()
    Dim Filename As String, FileTitle As String
    Dim Result As Boolean
    Dim i As Integer, j As Integer
    
    Result = VBGetSaveFileName(Filename, FileTitle, True, _
        "Tileinfo (*.tli)|*.tli", 1, App.Path, "Save Tileinfo", _
        "tli", Me.hWnd, 0)
        
    If Result Then
        Open Filename For Binary Access Write As #1
        For i = 0 To 5
            For j = 0 To TileCount - 1
                Put #1, , TileData(i, j)
            Next
        Next
        Close #1
        
        'Create patch file
        Filename = Left$(Filename, InStr(Filename, FileTitle) - 1)
        FileTitle = Left$(FileTitle, InStr(FileTitle, ".") - 1)
        Filename = Filename & FileTitle & ".pat"
        Open Filename For Output As #1
        Print #1, "#Tile info patching script for Keen " & Trim(Str(Episode))
        Print #1, "%ext ck" & Trim(Str(Episode))
        Print #1, ""
        Select Case Episode
            Case 1
                Print #1, "%version 1.1"
                Print #1, "%patchfile 0x131F8 " & FileTitle & ".tli"
                Print #1, ""
                Print #1, "%version 1.31"
                Print #1, "%patchfile 0x130F8 " & FileTitle & ".tli"
                Print #1, ""
            Case 2
                Print #1, "%version 1.0"
                Print #1, "%patchfile 0x17938 " & FileTitle & ".tli"
                Print #1, ""
                Print #1, "%version 1.31"
                Print #1, "%patchfile 0x17828 " & FileTitle & ".tli"
                Print #1, ""
            Case 3
                Print #1, "%version 1.0"
                Print #1, "%patchfile 0x199F8 " & FileTitle & ".tli"
                Print #1, ""
                Print #1, "%version 1.31"
                Print #1, "%patchfile 0x198C8 " & FileTitle & ".tli"
                Print #1, ""
        End Select
        Print #1, "%end"
        Close #1
    End If
End Sub

Private Sub imgTiles_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    SelectedTile = (x \ Screen.TwipsPerPixelX) \ 16 + ((y \ Screen.TwipsPerPixelY) \ 16) * 13
    SelectTile SelectedTile
End Sub

Private Sub lstBehaviour_Click()
    Dim n As Integer
    Select Case lstBehaviour.ListIndex
        Case lstBehaviour.ListCount - 1
            n = -1
        Case lstBehaviour.ListCount - 2
            n = -2
        Case 0 To &H1C
            n = lstBehaviour.ListIndex
        Case Else
            n = 0
    End Select
    If TileData(TBEHAVE, SelectedTile) <> n Then _
        TileData(TBEHAVE, SelectedTile) = n

End Sub

Private Sub lstTop_Click()
    Dim n As Integer
    Select Case lstTop.ListIndex
        Case 0 To 3:
            n = lstTop.ListIndex
        Case Else:
            n = 0
    End Select
    If TileData(TTOP, SelectedTile) <> n Then
        TileData(TTOP, SelectedTile) = n
    End If
End Sub

Private Sub picTile_Paint()
    If Not TilePicture Is Nothing Then
        picTile.PaintPicture TilePicture, 0, 0, _
            ScaleX(picTile.ScaleWidth, vbPixels, vbTwips), _
            ScaleY(picTile.ScaleHeight, vbPixels, vbTwips), _
            (SelectedTile Mod 13) * 16, (SelectedTile \ 13) * 16, _
            ScaleX(16, vbPixels, vbTwips), _
            ScaleY(16, vbPixels, vbTwips), vbSrcCopy
    End If
End Sub

Private Sub scrTiles_Change()
    imgTiles.TOp = -scrTiles.Value
    SelectTile SelectedTile
End Sub

Private Sub scrTiles_Scroll()
    imgTiles.TOp = -scrTiles.Value
    SelectTile SelectedTile
End Sub

Private Sub SelectTile(ByVal n As Integer)
    SelectedTile = n
    shpSelect.Move (n Mod 13) * 16 - 2, (n \ 13) * 16 - 2 - scrTiles.Value
    shpSelect.Visible = True
    lblTileNum.Caption = "Current Tile: " & Trim(Str(SelectedTile))
    picTile.Refresh
    
    'Update the info
    Select Case TileData(TANIM, SelectedTile)
        Case 1
            lstFrames.ListIndex = 0
        Case 2
            lstFrames.ListIndex = 1
        Case 4
            lstFrames.ListIndex = 2
        Case Else
            lstFrames.ListIndex = -1
    End Select
    Select Case TileData(TBEHAVE, SelectedTile)
        Case -1
            lstBehaviour.ListIndex = lstBehaviour.ListCount - 1
        Case -2
            lstBehaviour.ListIndex = lstBehaviour.ListCount - 2
        Case 0 To &H1C
            lstBehaviour.ListIndex = TileData(TBEHAVE, SelectedTile)
        Case Else
            lstBehaviour.ListIndex = -1
    End Select
    Select Case TileData(TTOP, SelectedTile)
        Case 0 To 3
            lstTop.ListIndex = TileData(TTOP, SelectedTile)
        Case Else
            lstTop.ListIndex = -1
    End Select
    Select Case TileData(TRIGHT, SelectedTile)
        Case 0, 1
            chkRight.Value = TileData(TRIGHT, SelectedTile)
        Case Else
            chkRight.Value = 0
    End Select
    Select Case TileData(TBOTTOM, SelectedTile)
        Case 0, 1
            chkBottom.Value = TileData(TBOTTOM, SelectedTile)
        Case Else
            chkBottom.Value = 0
    End Select
    Select Case TileData(TLEFT, SelectedTile)
        Case 0, 1
            chkLeft.Value = TileData(TLEFT, SelectedTile)
        Case Else
            chkLeft.Value = 0
    End Select
End Sub
