VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IUniPicture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'**********************************************
'Header Data to be written when this Class is initially
'created as a VB Component in the Project
'Only Called when the Component is Initially created
'**********************************************
'
'***************************************************************
'   You are authorized to use/modify/distribute the code in this
'   UniPicture.cls class object and IuniPicture.cls provided you
'   include the notices enclosed by the words StartNotice and End Notice
'
'************************ StartNotice ************************
'   UniPicture - file UniPicture.cls
'   UniPicture - file IuniPicture.cls
'
'   Windows only permits 1024 active bitmap/icon handles
'   UniPicture provides a method to store in excess of
'   1024 Bitmaps/Icons without depleting user/gdi heap memory
'   and the restrictions imposed by the operating system
'
'   UniPicture also provides you with Procedures to:
'   1.  Store the raw data in a StdPicture Object in the UniPicture Object
'   2.  Convert a Windows BitMap Handle to a StdPicture
'   3.  Convert a Windows Icon Handle to a StdPicture
'   4.  Obtain a Windows Bitmap Handle for a copy of a StdPicture
'   5.  Obtain a Windows Icon Handle for a copy of a StdPicture
'   6.  Render the BitMap held by a UniPicture Object
'   7.  Render the Icon held by a UniPicture Object
'   8.  Resize and Render the Icon held by a UniPicture Object
'   9.  Retieve the Bitmap/Icon held by a UniPicture Object as
'       an array of Bytes.
'   10. Persist the Bitmap/Icon held by a UniPicture Object as
'       to a PropertyBag.
'   11. Create a copy of a stdPicture or a BitMap/Icon Handle
'
'   UniPicture is supplied as 32 Bit Visual Basic 5.x and/or 6.x Source Code
'
'   You have a royalty-free right to use, modify, reproduce
'   and distribute the code for UniPicture.cls and IuniPicture.cls
'   in any way you find usefull, provided:-
'   1.  you rename the class object UniPicture.cls
'   2.  you implement the IuniPict Interface
'   2.  do not use the name UniPicture in any ActiveX object
'   3.  You do not alter the data types and procedure
'       declarations herein or interfere with version compatability
'       of the UniPicture and IuniPicture interfaces
'   4.  Provided that you agree that Brian D. Parkinson
'       has no warranty, obligations or liability for any
'       Application Programs/Files distributed incorporating the code.
'
'   You may add your own procedures to perform additional operations
'   only if you do not call the class object UniPicture or implement it as
'   a member of the IuniPict Interface.
'-------------------------------------------------------------------------------
'
'   Copyright  1999 Brian D. Parkinson(brian@Iceminster.com). All rights reserved.
'   This file is one of a number of source code files in ClassWiz Add-In which
'   generates Visual Basic Code for various types of Lists, Keyed Lists, Queues,
'   PropertyBags and Classes and Interfaces.
'
'-------------------------------------------------------------------------------
'   ClassWiz5 is a Visual Basic Code Generator Add-In developed by Brian Parkinson
'   of www.iceminster.com. Information about ClassWiz is provided at the end of
'   the code for UniPicture.
'
'   Source code for ICWPropertyBag, CWPropertyBag and modClassWiz may not be distributed
'   and you require a licenced version of ClassWiz to obtain the VB Code for these objects.
'-------------------------------------------------------------------------------
'
'   If you register your use of this code by Email to 'brian@iceminster.com' you will be
'   kept informed of any changes or other issues related to the code.
'
'-------------------------------------------------------------------------------
'   You are authorized to use/modify/distribute the code in this
'   UniPicture.cls class object and IuniPicture.cls provided you
'   include the notices enclosed by the words StartNotice and End Notice
'************************ EndNotice ************************
'********************************************************************************
'
'CODE WAS GENERATED BY CLASSWIZ CODE GENERATOR - 9/12/00 9:03:59 AM
'
'********************************************************************************
'
    'The  Programs, Add-Ins, Controls, DLLs and Classes are supplied
    'as 32 Bit Visual Basic 5.x and/or 6.x Source Code
    'Code is written totally in Visual Basic 5.x and/or 6.x
'
'********************************************************************************
'
    'Copyright  1999 Brian D. Parkinson(www.Iceminster.com). All rights reserved.
'
'Please Contact me at Email: "brian@iceminster.com" with any comments/suggestions
'
'********************************************************************************
    'This file is one of a number of source code files which generates Visual Basic
    'Code for various types of Lists, Keyed Lists, Queues PropertyBags and Classes and Interfaces.
'********************************************************************************
    'PROVIDED YOU HAVE A LICENCE FOR THIS SOURCE CODE.
    'You have a royalty-free right to use, modify, reproduce and distribute the code
    'if included in your COMPILED Executable Programs in any way you find usefull,
    'provided that you agree that Brian D. Parkinson has no warranty, obligations or
    'liability for any Application Programs/Files distributed.
'********************************************************************************
    'If you register your use of this code by Email to brian@iceminster.com you will be
    'kept informed of any changes or other issues related to the code and any free code.
'********************************************************************************
'General Declares contained in modClassWiz
'General Error Constants contained in modClassWiz
'Sort Procedures and Compare Functions contained in modClassWiz
'Include module modClassWiz in File ClassWiz.Bas in all projects using ClassWiz Componentes
'********************************************************************************

'Set this to 1 to enable debug code in this class
#Const CWDebugMode = 0
#If CWDebugMode Then
'local variable to hold the serialized class ID that was created in Class_Initialize
Private mlClassDebugID As Long
#End If
    'Add the following to a Public module if modClassWiz - modClassWiz.bas not included
'If CWDebugMode Then
    'Public gIUniPicture As Long
'End If

'********************************************************************************

'//Warning - DO NOT Remove - ClassWiz Class:IUniPicture:1

'********************************************************************************


Public Property Let BitMap(BitMap As Long)
'//Warning - DO NOT Remove - ClassWizMap:1025:BitMap
End Property

Public Function BLACKNESS() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:BLACKNESS
End Function

Public Property Let Changed(Changed As Boolean)
'//Warning - DO NOT Remove - ClassWizMap:1025:Changed
End Property

Public Property Get Changed() As Boolean
'//Warning - DO NOT Remove - ClassWizMap:1025:Changed
End Property

Public Function ClassName() As String
'//Warning - DO NOT Remove - ClassWizMap:1025:ClassName
End Function

Public Sub Clear()
'//Warning - DO NOT Remove - ClassWizMap:1025:Clear
End Sub

Public Sub CopyFrom(oOriginal As Object, Optional bChanged As Boolean = False)
'//Warning - DO NOT Remove - ClassWizMap:1025:CopyFrom
End Sub

Public Function DSTINVERT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:DSTINVERT
End Function

Public Function Handle() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:Handle
End Function

Public Property Get Height() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:Height
End Property

Public Property Get HeightPixels() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:HeightPixels
End Property

Public Property Let Icon(Icon As Long)
'//Warning - DO NOT Remove - ClassWizMap:1025:Icon
End Property

Public Function LoadBitmap(hdc As Long, Width As Long, Height As Long) As Boolean
'//Warning - DO NOT Remove - ClassWizMap:1025:LoadBitmap
End Function

Public Function MERGECOPY() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:MERGECOPY
End Function

Public Function MERGEPAINT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:MERGEPAINT
End Function

Public Function NOTSRCCOPY() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:NOTSRCCOPY
End Function

Public Function NOTSRCERASE() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:NOTSRCERASE
End Function

Public Function Object() As Object
'//Warning - DO NOT Remove - ClassWizMap:1025:Object
End Function

Public Function PATCOPY() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:PATCOPY
End Function

Public Function PATINVERT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:PATINVERT
End Function

Public Function PATPAINT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:PATPAINT
End Function

Public Property Set Picture(Picture As StdPicture)
'//Warning - DO NOT Remove - ClassWizMap:1025:Picture
End Property

Public Property Get Picture() As StdPicture
'//Warning - DO NOT Remove - ClassWizMap:1025:Picture
End Property

Public Function PictureFn(Picture As StdPicture) As Boolean
'//Warning - DO NOT Remove - ClassWizMap:1025:Picture
End Function

Public Function PicType() As PictureTypeConstants
'//Warning - DO NOT Remove - ClassWizMap:1025:PicType
End Function

Public Function ReleaseHandle() As Boolean
'//Warning - DO NOT Remove - ClassWizMap:1025:ReleaseHandle
End Function

Public Function Render(hdc As Long, ByVal x As Long, ByVal y As Long, Optional ByVal WidthPixels As Long, Optional ByVal HeightPixels As Long, Optional ByVal xSrc As Long, Optional ByVal ySrc As Long, Optional ByVal cxSrc As Long, Optional ByVal cySrc As Long, Optional ByVal dwRop As Long) As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:Render
End Function

Public Function SRCAND() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:SRCAND
End Function

Public Function SRCCOPY() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:SRCCOPY
End Function

Public Function SRCERASE() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:SRCERASE
End Function

Public Function SRCINVERT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:SRCINVERT
End Function

Public Function SRCPAINT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:SRCPAINT
End Function

Public Function WHITENESS() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:WHITENESS
End Function

Public Property Get Width() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:Width
End Property

Public Property Get WidthPixels() As Long
'//Warning - DO NOT Remove - ClassWizMap:1025:WidthPixels
End Property

