VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UniPicture"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'**********************************************
'Header Data to be written when this Class is initially
'created as a VB Component in the Project
'Only Called when the Component is Initially created
'**********************************************
'
'***************************************************************
'   You are authorized to use/modify/distribute the code in this
'   UniPicture.cls class object and IuniPicture.cls provided you
'   include the notices enclosed by the words StartNotice and End Notice
'
'************************ StartNotice ************************************
'   If you register your use of this code by Email to 'brian@iceminster.com'
'   you will be kept informed of any changes or other issues related to the code.
'   You will also be provided with access to a special Code area of iceminster.com.
'
'   It is suggested you place UniPicture and IUniPicture in an
'   ActiveX DLL. This maintains a constant GUID for the Objects
'
'   UniPicture - file UniPicture.cls
'   UniPicture - file IuniPicture.cls
'
'   Windows only permits 1024 active bitmap/icon handles
'   UniPicture provides a method to store in excess of
'   1024 Bitmaps/Icons without depleting user/gdi heap memory
'   and the restrictions imposed by the operating system
'
'   UniPicture also provides you with Procedures to:
'   1.  Store the raw data of a StdPicture Object in the UniPicture Object
'   2.  Convert a Windows BitMap Handle to a StdPicture
'   3.  Convert a Windows Icon Handle to a StdPicture
'   4.  Obtain a Windows Bitmap Handle for a copy of a StdPicture
'   5.  Obtain a Windows Icon Handle for a copy of a StdPicture
'   6.  Render the BitMap held by a UniPicture Object to a hDC
'   7.  Render the Icon held by a UniPicture Object to a hDC
'   8.  Resize and Render the Icon held by a UniPicture Object to a hDC
'   9.  Retieve the Bitmap/Icon held by a UniPicture Object as
'       an array of Bytes.
'   10. Persist the Bitmap/Icon held by a UniPicture Object
'       to a PropertyBag.
'   11. Create a copy of a stdPicture or a BitMap/Icon Handle
'
'   UniPicture is supplied as 32 Bit Visual Basic 5.x and/or 6.x Source Code
'
'   You have a royalty-free right to use, modify, reproduce
'   and distribute the code for UniPicture.cls and IuniPicture.cls
'   in any way you find usefull, provided:-
'   1.  you rename the class object UniPicture.cls
'   2.  you implement the IuniPict Interface
'   2.  you do not use the name UniPicture in any ActiveX object
'   3.  You do not alter the data types and procedure
'       declarations herein or interfere with version compatability
'       of the base UniPicture and IuniPicture interfaces
'   4.  Provided that you agree that Brian D. Parkinson
'       has no warranty, obligations or liability for any
'       Application Programs/Files distributed incorporating the code.
'
'   You may add your own procedures to perform additional operations
'   only if you do not call the class object UniPicture or implement it as
'   a member of the IuniPict Interface.
'-------------------------------------------------------------------------------
'
'   Copyright  1999 Brian D. Parkinson(brian@Iceminster.com). All rights reserved.
'   This file is one of a number of source code files in ClassWiz Add-In which
'   generates Visual Basic Code for various types of Lists, Keyed Lists, Queues,
'   PropertyBags and Classes and Interfaces.
'
'-------------------------------------------------------------------------------
'   ClassWiz5 is a Visual Basic Code Generator Add-In developed by Brian Parkinson
'   of www.iceminster.com. Information about ClassWiz is provided at the end of
'   the code for UniPicture.
'
'   Source code for ICWPropertyBag, CWPropertyBag and modClassWiz may not be distributed
'   and you require a licenced version of ClassWiz to obtain the VB Code for these objects.
'-------------------------------------------------------------------------------
'
'-------------------------------------------------------------------------------
'   You are authorized to use/modify/distribute the code in this
'   UniPicture.cls class object and IuniPicture.cls provided you
'   include the notices enclosed by the words StartNotice and End Notice
'************************ EndNotice ************************
'********************************************************************************
'
'CODE WAS GENERATED BY CLASSWIZ CODE GENERATOR - 9/12/00 9:04:04 AM
'
'********************************************************************************
'
    'The  Programs, Add-Ins, Controls, DLLs and Classes are supplied
    'as 32 Bit Visual Basic 5.x and/or 6.x Source Code
    'Code is written totally in Visual Basic 5.x and/or 6.x
'
'********************************************************************************
'
    'Copyright  1999 Brian D. Parkinson(www.Iceminster.com). All rights reserved.
'
'Please Contact me at Email: "brian@iceminster.com" with any comments/suggestions
'
'********************************************************************************
    'This file is one of a number of source code files which generates Visual Basic
    'Code for various types of Lists, Keyed Lists, Queues PropertyBags and Classes and Interfaces.
'********************************************************************************
    'PROVIDED YOU HAVE A LICENCE FOR THIS SOURCE CODE.
    'You have a royalty-free right to use, modify, reproduce and distribute the code
    'if included in your COMPILED Executable Programs in any way you find usefull,
    'provided that you agree that Brian D. Parkinson has no warranty, obligations or
    'liability for any Application Programs/Files distributed.
'********************************************************************************
    'If you register your use of this code by Email to brian@iceminster.com you will be
    'kept informed of any changes or other issues related to the code and any free code.
'********************************************************************************
'General Declares contained in modClassWiz
'General Error Constants contained in modClassWiz
'Sort Procedures and Compare Functions contained in modClassWiz
'Include module modClassWiz in File ClassWiz.Bas in all projects using ClassWiz Componentes
'********************************************************************************

'Set this to 1 to enable debug code in this class
#Const CWDebugMode = 0
#If CWDebugMode Then
'local variable to hold the serialized class ID that was created in Class_Initialize
Private mlClassDebugID As Long
#End If
    'Add the following to a Public module if modClassWiz - modClassWiz.bas not included
'If CWDebugMode Then
    'Public gUniPicture As Long
'End If



'********************************************************************************
'Updated 31 January,2001... If Ret = bm.bm_lngHeight changed to If Ret Then
'********************************************************************************

'//Warning - DO NOT Remove - ClassWiz Class:UniPicture:1

'********************************************************************************

Private Const BI_RGB = 0&              'used by upicGetDIBits
Private Const DIB_RGB_COLORS = 0       'color table in RGBs
Private Const CBM_CREATEDIB = &H2      'create DIB Bitmap
Private Const CBM_INIT = &H4           'initialize Bitmap
Private Const cMin = 4                 'Min size of m_DataArr if holding data

'Used by upicOleCreatePictureIndirect
Private Type CLSID
    id(15) As Byte
End Type

'RGBColor Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

'Length = 40 bytes ..always use len(bmInfo) for length
Private Type BitmapINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type BitmapINFO
    bmiHeader As BitmapINFOHEADER
    bmiColors(256) As RGBQUAD
End Type

'Private Type used by UniPicture for storing data in m_DataArr array
'BitMap Data follows the BitMapINFOEX structure in m_DataArr Array
Private Type BitmapINFOEX
    PicType As PictureTypeConstants
    bmiHeader As BitmapINFOHEADER
    bmiColors(256) As RGBQUAD
End Type

Private Type BitMapType
    bmType As Long
    bm_lngWidth As Long
    bm_lngHeight As Long
    bm_lngWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

'Used to load BitMap into StdPicture
Private Type TypeBitmap
    cbSizeOfStruct As Long
    PicType As PictureTypeConstants
    hBitmap As Long
    hPal As Long
End Type

Private Type TypeMetafile
    cbSizeOfStruct As Long
    PicType As PictureTypeConstants
    hmeta As Long
    xExt As Long
    yExt As Long
End Type

Private Type TypeEnhMetafile
    cbSizeOfStruct As Long
    PicType As PictureTypeConstants
    henhmeta As Long
End Type

Private Type IconInfo
    fIcon As Long
    xHotSpot As Long
    yHotSpot As Long
    hbmMask As Long
    hbmColor As Long
End Type

'Private Type used by UniPicture for storing data in m_DataArr array
'bmMask data stored after IconInfoEx structure
'LengthbmMask is Length of BitMapMask stored in m_DataArr array
Private Type ICONINFOEX
    PicType As PictureTypeConstants
    LengthbmMask As Long
    IconInfo As IconInfo
End Type

'Used to load Icon into StdPicture
Private Type TypeIcon
    cbSizeOfStruct As Long
    PicType As PictureTypeConstants
    hIcon As Long
End Type

'Windows API used by this class
Private Declare Sub upicCopyMemory Lib "Kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)

Private Declare Function upicCreateCompatibleDC Lib "gdi32" Alias "CreateCompatibleDC" (ByVal hdc As Long) As Long
Private Declare Function upicBitBlt Lib "gdi32" Alias "BitBlt" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function upicCreateCompatibleBitmap Lib "gdi32" Alias "CreateCompatibleBitmap" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function upicCreateDIBitmapByNum Lib "gdi32" Alias "CreateDIBitmap" (ByVal hdc As Long, lpInfoHeader As Long, ByVal dwUsage As Long, lpInitBits As Any, ByVal lpInitInfo As Long, ByVal wUsage As Long) As Long
Private Declare Function upicDeleteDC Lib "gdi32" Alias "DeleteDC" (ByVal hdc As Long) As Long
Private Declare Function upicDeleteObject Lib "gdi32" Alias "DeleteObject" (ByVal hObject As Long) As Long
Private Declare Function upicGetDIBits Lib "gdi32" Alias "GetDIBits" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BitmapINFO, ByVal wUsage As Long) As Long
Private Declare Function upicGetDIBitsByNum Lib "gdi32" Alias "GetDIBits" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, ByVal lpBits As Long, ByVal lpBI As Long, ByVal wUsage As Long) As Long
Private Declare Function upicGetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function upicOleCreatePictureIndirect& Lib "oleaut32.dll" Alias "OleCreatePictureIndirect" (pPicDesc As Any, riid As CLSID, ByVal fown As Long, lpunk As Object)
Private Declare Function upicSelectObject Lib "gdi32" Alias "SelectObject" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function upicStretchBlt Lib "gdi32" Alias "StretchBlt" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

'Icon API's
Private Declare Function upicCreateIconIndirect Lib "user32" Alias "CreateIconIndirect" (piconinfo As IconInfo) As Long
Private Declare Function upicCreateIconIndirectByNum Lib "user32" Alias "CreateIconIndirect" (ByVal piconinfo As Long) As Long
Private Declare Function upicDestroyIcon Lib "user32" Alias "DestroyIcon" (ByVal hIcon As Long) As Long
Private Declare Function upicDrawIcon Lib "user32" Alias "DrawIcon" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal hIcon As Long) As Long
Private Declare Function upicGetIconInfo Lib "user32" Alias "GetIconInfo" (ByVal hIcon As Long, piconinfo As IconInfo) As Long
Private Declare Function upicGetIconInfoByNum Lib "user32" Alias "GetIconInfo" (ByVal hIcon As Long, ByVal piconinfo As Long) As Long

'Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
'Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function upicGetSysColor Lib "user32" Alias "GetSysColor" (ByVal nIndex As Long) As Long

'-------------------------------------------------------------------------------
'Implemented Interfaces
Implements IUniPicture
'-------------------------------------------------------------------------------

'-------------------------------------------------------------------------------
'Private Members
Private m_blnChanged As Boolean
Private m_lngHeight As Long 'height in Hi_Metic
Private m_lngWidth As Long 'width in Hi_Metic
Private m_lngHeightPixels As Long 'height in Pixels
Private m_lngWidthPixels As Long 'width in Pixels
'-------------------------------------------------------------------------------
'Used to store BitMap and Icon data
Private m_DataArr() As Byte
'Format of m_DataArr
'If BitMap
'Byte                    Name                 Description
'0  to 3                PicType         PictureTypeConstants
'4  to 43               bmiHeader       BitmapINFOHEADER
'44 to 1067             bmiColors(256)  RGBQUAD
'1068 to UBound(m_DataArr)              BitMap Bytes
'
'If Icon
'Byte                    Name                 Description
'0  to 3                PicType         PictureTypeConstants
'4  to 7            LengthbmMask        Length of Mask
'8  to 27           IconInfo            IconInfo type
'28 to 28 + lengthbmMask -1              BMMask Data
'28 + lengthbmMask - 1 to ubound(m_DataArr)    Icon MB data
'
'-------------------------------------------------------------------------------
'Handle returned to a calling program
'This handle must be released by a call to ReleaseHandle
'or call to DeleteObject/DestroyIcon as the case may be
'and call Clear
Private m_lngHandle As Long
'Implements ICWPropertyBag



'***************************************************************
'***************************************************************
'Private Class/Helper Procedures
'***************************************************************
'***************************************************************
'Create a Bitmap handle from a byte buffer containing data
'formatted using BitmapINFOEX
'WARNING
'Use of this function can result in depletion of available
'User32 and DIBENG.DLL resource memory heaps and Handles for Icons.
'If this happens the operating system will seize up
'so minimize retention of Bitmap Handles in your calling Program.
'Not recommended for use outside UniPicture
'This is mananged without problem within UniPicture Objects
'***************************************************************
Private Function BitmapFromDataArr(Bytes() As Byte) As Long
'//Warning - DO NOT Remove - ClassWizMap:512:BitmapFromDataArr
On Error GoTo ErrorHandler
Dim bmInfoEX As BitmapINFOEX
Dim tmpDC As Long, newBM As Long

    If UBound(Bytes) - 1 > Len(bmInfoEX) Then
        'Create a compatable device context
        tmpDC = upicCreateCompatibleDC(0)
        If tmpDC <> 0 Then
            'Create DIB
            BitmapFromDataArr = upicCreateDIBitmapByNum(tmpDC, ByVal VarPtr(Bytes(Len(bmInfoEX.PicType))), CBM_INIT Or CBM_CREATEDIB, ByVal VarPtr(Bytes(Len(bmInfoEX))), ByVal VarPtr(Bytes(4)), DIB_RGB_COLORS)
            'Release the temp Device Context
            Call upicDeleteDC(tmpDC)
        End If
    End If
    Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::BitmapFromDataArr", ""
End Function

'***************************************************************
'Load an BitMap in a Bitmap handle into a Byte array
'***************************************************************
Public Function BitmapToBytes(hBitmap As Long, Bytes() As Byte) As Long
'//Warning - DO NOT Remove - ClassWizMap:512:BitmapToBytes
On Error GoTo ErrorHandler
Dim gHnd As Long, gPtr As Long
Dim Ret As Long
Dim tmpDC As Long
Dim bmInfoEX As BitmapINFOEX
Dim bm As BitMapType

        If hBitmap = 0 Then Exit Function
        If upicGetObjectAPI(hBitmap, Len(bm), bm) = 0 Then
            ' Returns zero on error
            Exit Function
        End If

        ReDim Bytes(0 To 0) As Byte
        IuniPicture_ReleaseHandle
        m_lngHeightPixels = 0
        m_lngWidthPixels = 0
        m_lngHeight = 0
        m_lngWidth = 0

        'This is a BitMap
        bmInfoEX.PicType = vbPicTypeBitmap

        With bmInfoEX.bmiHeader
            .biSize = Len(bmInfoEX.bmiHeader)
            .biWidth = bm.bm_lngWidth
            .biHeight = bm.bm_lngHeight
            'Width and Height in Pixels
            m_lngHeightPixels = bm.bm_lngHeight
            m_lngWidthPixels = bm.bm_lngWidth
            'Width and Height in HiMetic
            m_lngWidth = ScaleX(m_lngWidthPixels, False)
            m_lngHeight = ScaleY(m_lngHeightPixels, False)

            .biPlanes = bm.bmPlanes
            .biBitCount = bm.bmBitsPixel
            .biCompression = BI_RGB
            'Create a Temp Device Context
            tmpDC = upicCreateCompatibleDC(0)
            If tmpDC <> 0 Then
                'get information on the Bitmap
                Ret = upicGetDIBitsByNum(tmpDC, hBitmap, 0, bm.bm_lngHeight, ByVal 0&, ByVal VarPtr(bmInfoEX.bmiHeader), DIB_RGB_COLORS)
                If Ret Then
                    ReDim Bytes(0 To .biSizeImage - 1 + Len(bmInfoEX))
                    upicCopyMemory ByVal VarPtr(Bytes(0)), bmInfoEX, Len(bmInfoEX)
                    Ret = upicGetDIBitsByNum(tmpDC, hBitmap, 0, bm.bm_lngHeight, VarPtr(Bytes(Len(bmInfoEX))), VarPtr(Bytes(4)), DIB_RGB_COLORS)
                    BitmapToBytes = Len(bmInfoEX)
                End If
                'Clean up the device contexts
                Call upicDeleteDC(tmpDC)
            End If
        End With
        m_blnChanged = True
        Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::BitmapToBytes", ""
End Function

'***************************************************************
'Retrieve the BitMap Handle for the Icon
'***************************************************************
Private Function BMHandleFromIconDataArr(Bytes() As Byte) As Long
'//Warning - DO NOT Remove - ClassWizMap:512:BMHandleFromIconDataArr
On Error GoTo ErrorHandler
Dim iInfo As ICONINFOEX
Dim Ret As Long
Dim Buffer() As Byte
Dim LenInfo As Long
Dim newBM As Long

    LenInfo = Len(iInfo)
    If UBound(Bytes) > LenInfo - 1 Then
        upicCopyMemory iInfo, ByVal VarPtr(Bytes(0)), LenInfo
        ReDim Buffer(0 To UBound(Bytes) - iInfo.LengthbmMask) As Byte
        upicCopyMemory ByVal VarPtr(Buffer(0)), ByVal VarPtr(Bytes(iInfo.LengthbmMask)) + LenInfo, UBound(Bytes()) - iInfo.LengthbmMask - LenInfo
        newBM = BitmapFromDataArr(Buffer())
        Erase Buffer
        If newBM Then
            BMHandleFromIconDataArr = newBM
        End If
    End If
    Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::IconPictureFromDataArr", ""
End Function

'***************************************************************
'Retrieve the Mask BitMap Handle for the Icon
'***************************************************************
Private Function BMMaskHandleFromIconDataArr(Bytes() As Byte) As Long
'//Warning - DO NOT Remove - ClassWizMap:512:BMMaskHandleFromIconDataArr
On Error GoTo ErrorHandler
Dim iInfo As ICONINFOEX
Dim Ret As Long
Dim Buffer() As Byte
Dim LenInfo As Long
Dim newBM As Long

    LenInfo = Len(iInfo)
    If UBound(Bytes) > LenInfo - 1 Then
        upicCopyMemory iInfo, ByVal VarPtr(Bytes(0)), LenInfo
        ReDim Buffer(0 To iInfo.LengthbmMask - 1) As Byte
        upicCopyMemory ByVal VarPtr(Buffer(0)), ByVal VarPtr(Bytes(LenInfo)), iInfo.LengthbmMask
        BMMaskHandleFromIconDataArr = BitmapFromDataArr(Buffer())
        Erase Buffer
    End If
    Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::BMMaskHandleFromIconDataArr", ""
End Function

'***************************************************************
'Helper if required for some operation
'Converts VBSystem Colors to RGB Colors
'***************************************************************
Private Function CheckSysColor(ByVal nColor As Long) As Long
'//Warning - DO NOT Remove - ClassWizMap:512:CheckSysColor
    If nColor < 0 Then
        nColor = nColor And Not &H80000000
        CheckSysColor = upicGetSysColor(nColor)
    Else
        CheckSysColor = nColor
    End If
End Function

'***************************************************************
Private Sub Class_Initialize()
'//Warning - DO NOT Remove - ClassWizMap:1027:Class_Initialize
On Error Resume Next
#If CWDebugMode Then
'get the next available class ID, and print out
'that the class was created successfully
    mlClassDebugID = CWGetNextClassDebugID()
    gUniPicture = gUniPicture + 1
    'Debug.Print "Initialize : " TypeName(Me)" : Instance "mlClassDebugID" : Number of Instances = "gUniPicture
#End If '********************************

    'Initialize List Members and Standard List Members
    Clear

'-------------------------------------------------------------------------------------
'User Code follows

'-------------------------------------------------------------------------------------

End Sub

'***************************************************************
Private Sub Class_Terminate()
'//Warning - DO NOT Remove - ClassWizMap:1027:Class_Terminate
On Error Resume Next
    'Clean up to prevent memory leaks
#If CWDebugMode Then
    gUniPicture = gUniPicture - 1
    'Debug.Print "Terminate : "TypeName(Me)": Instance "mlClassDebugID" : Number of Instances = "gUniPicture
#End If '********************************

    'Release any Handle
    If m_lngHandle > 0 Then IuniPicture_ReleaseHandle

'-------------------------------------------------------------------------------------
'User Code follows
'-------------------------------------------------------------------------------------
End Sub

'***************************************************************
Private Sub ClassMembersToNull()
'//Warning - DO NOT Remove - ClassWizMap:512:ClassMembersToNull
'Always included when class first written
On Error Resume Next
        'Initialize to default values
'//Warning - DO NOT Remove - ClassWiz ClassMemberNullStart
        m_blnChanged = 0
'//Warning - DO NOT Remove - ClassWiz ClassMemberNullEnd
End Sub

'***************************************************************
Public Function ClassName() As String
'//Warning - DO NOT Remove - ClassWizMap:512:ClassName
On Error Resume Next
    'Raise a dummy error
    Err.Raise 9999
    'the ClassName is in Err.Source
    ClassName = Err.Source & "." & TypeName(Me)
    Err.Clear
End Function

'***************************************************************
Private Sub Clear()
'//Warning - DO NOT Remove - ClassWizMap:512:Clear
On Error Resume Next

    If m_lngHandle > 0 Then IuniPicture_ReleaseHandle
    'Clean up to prevent memory leaks
    ClassMembersToNull

    'Initialize to default values
    m_blnChanged = False

End Sub

'***************************************************************
'Used to copy Bitmaps just in case the bHandle has been
'selected into a Device Context. Windows only permits
'the Bitmap to be loaded in one device at a time
'***************************************************************
Private Function CopyBitmap(ByVal hBitmap As Long) As Long
'//Warning - DO NOT Remove - ClassWizMap:512:CopyBitmap
On Error GoTo ErrorHandler
Dim bm As BitMapType
Dim newBM As Long
Dim srcDC As Long, DestDC As Long
Dim oldbmsrc As Long, oldbmdest As Long

    'Get the information for this Bitmap
    'Returns zero on error
    If upicGetObjectAPI(hBitmap, Len(bm), bm) = 0 Then Exit Function

    bm.bmBits = 0
    'Get device contexts - set up source
    srcDC = upicCreateCompatibleDC(0)
    If srcDC <> 0 Then
        oldbmsrc = upicSelectObject(srcDC, hBitmap)
        ' set up destination
        If oldbmsrc <> 0 Then
            DestDC = upicCreateCompatibleDC(0)
            If DestDC <> 0 Then
                newBM = upicCreateCompatibleBitmap(srcDC, bm.bm_lngWidth, bm.bm_lngHeight)
                If newBM Then
                'Now do the copy
                    oldbmdest = upicSelectObject(DestDC, newBM)
                    Call upicBitBlt(DestDC, 0, 0, bm.bm_lngWidth, bm.bm_lngHeight, srcDC, 0, 0, IuniPicture_SRCCOPY)
                End If
                ' Clean up the device contexts
                Call upicSelectObject(DestDC, oldbmdest)
                Call upicDeleteDC(DestDC)
            End If
            Call upicSelectObject(srcDC, oldbmsrc)
        End If
        Call upicDeleteDC(srcDC)
        CopyBitmap = newBM
    End If
    Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::CopyBitmap", ""
End Function

'*********************************************************************
'Copy Data from one object to another
'It is suggested that once you have completed an Object that you
'optimise this code and eliminate the need to call CopyItemValue
'
'How you do your copyfrom is up to you but obviously if you write
'your own code ClassWiz will not be able to update it if you
'make a change to your Properties
'After you have finalized your code you may want to change Object to
'an Object TypeName for additional speed.
'DO NOT change Object if the CopyFrom Method is an Implemented Interface
'This is a modification of the Standard CopyFrom generated by ClassWiz
'*********************************************************************
Private Sub CopyFrom(oOriginal As Object, Optional bChanged As Boolean = False)
'//Warning - DO NOT Remove - ClassWizMap:512:CopyFrom
On Error Resume Next
Dim Index As Long
Dim nCount As Long
Dim oObject As Object
Dim oIuniPicture As IUniPicture
'*********************************************************************
'*********************************************************************
    'The following is ClassWiz Generated code which you should modify to
    'your requirements once the Class Object structure is completed
    'Clear the current Data
    Clear

    'This assignment permits passing of an IuniPicture Interface or
    'the parent object implementing the IuniPicture Interface
    'Parent Object required to permit call to Friend Method CopyItemvalue
    Set oIuniPicture = oOriginal
    Set oObject = oIuniPicture.Object

    'Read Class members
    With oObject
'//Warning - DO NOT Remove - ClassWiz ClassMemberCopyToStart
        m_blnChanged = .CopyItemValue(1)
'//Warning - DO NOT Remove - ClassWiz ClassMemberCopyToEnd
        'Members Not updated by ClassWiz
        m_lngHeight = .CopyItemValue(991)
        m_lngWidth = .CopyItemValue(992)
        m_lngWidthPixels = .CopyItemValue(993)
        m_lngHeightPixels = .CopyItemValue(994)
        m_DataArr = .CopyItemValue(995)
    '-------------------------------------------------------------------------------------
    '
    'NOTE:
    'DO NOT COPY BITMAP/ICON HANDLE as this should
    'be unique to each UniPicture object
    '
    '-------------------------------------------------------------------------------------
    '-------------------------------------------------------------------------------------
    'Add Additional Friend Read Only Properties here used by CopyFrom
    '-------------------------------------------------------------------------------------
    '-------------------------------------------------------------------------------------
    'User Code follows
    '-------------------------------------------------------------------------------------

    End With

    If bChanged Then IuniPicture_Changed = True

End Sub

'*********************************************************************
Public Function CopyItemValue(ByVal ItemNumber As Long) As Variant
'//Warning - DO NOT Remove - ClassWizMap:512:CopyItemValue
On Error Resume Next
        Select Case ItemNumber
'//Warning - DO NOT Remove - ClassWiz ClassMemberCopyFromStart
        Case 1: CopyItemValue = m_blnChanged
'//Warning - DO NOT Remove - ClassWiz ClassMemberCopyToEnd
        'Members Not updated by ClassWiz
        Case 991: CopyItemValue = m_lngHeight
        Case 992: CopyItemValue = m_lngWidth
        Case 993: CopyItemValue = m_lngWidthPixels
        Case 994: CopyItemValue = m_lngHeightPixels
        Case 995: CopyItemValue = m_DataArr
        End Select
    '-------------------------------------------------------------------------------------
    'User Code follows
    '-------------------------------------------------------------------------------------

End Function

'***************************************************************
'WARNING
'Use of this function can result in depletion of available
'User32 and DIBENG.DLL resource memory heaps and Handles for Icons.
'If this happens the operating system will seize up
'Not recommended for use outside UniPicture
'This operates without problem within UniPicture
'***************************************************************
Private Function CreatePictureFromBitmap(ByVal hBitmap As Long, hPal As Long, Picture As IPictureDisp) As Boolean
'//Warning - DO NOT Remove - ClassWizMap:512:CreatePictureFromBitmap
On Error GoTo ErrorHandler
Dim Ret As Long
Dim newBM As TypeBitmap
Dim lpunk As IUnknown
Dim m_Unknown As CLSID
        With m_Unknown
            .id(15) = &H46
            .id(8) = &HC0
        End With

        If hBitmap = 0 Then Exit Function
        newBM.cbSizeOfStruct = Len(newBM)
        newBM.PicType = vbPicTypeBitmap
        'Need to copy Bitmaps just in case the bHandle has been
        'selected into a Device Context. Windows only permits
        'the Bitmap to be loaded in one device at a time
        newBM.hBitmap = CopyBitmap(hBitmap)
        If newBM.hBitmap Then
            newBM.hPal = hPal
            newBM.PicType = vbPicTypeBitmap
            Ret = upicOleCreatePictureIndirect(newBM, m_Unknown, 1, lpunk)
            If Ret = 0 Then
                Set Picture = lpunk
                CreatePictureFromBitmap = True
            End If
        End If
        Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::CreatePictureFromBitmap", ""
End Function

'***************************************************************
'WARNING
'Use of this function can result in depletion of available
'User32 and DIBENG.DLL resource memory heaps and Handles for Icons.
'If this happens the operating system will seize up
'Not recommended for use outside UniPicture
'This operates without problem within UniPicture
'***************************************************************
Private Function CreatePictureFromhIcon(ByVal hIcon As Long, hPal As Long, Picture As IPictureDisp) As Boolean
'//Warning - DO NOT Remove - ClassWizMap:512:CreatePictureFromhIcon
On Error GoTo ErrorHandler
Dim Ret As Long
Dim newIcon As TypeIcon
Dim lpunk As IUnknown
Dim m_Unknown As CLSID
        With m_Unknown
            .id(15) = &H46
            .id(8) = &HC0
        End With

        If hIcon = 0 Then Exit Function
        newIcon.cbSizeOfStruct = Len(newIcon)
        newIcon.PicType = vbPicTypeIcon
        newIcon.hIcon = hIcon
        If hIcon Then
            Ret = upicOleCreatePictureIndirect(newIcon, m_Unknown, 1, lpunk)
            If Ret = 0 Then
                Set Picture = lpunk
                CreatePictureFromhIcon = True
            End If
        End If
        Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::CreatePictureFromhIcon", ""
End Function

'***************************************************************
'Create an Icon handle from a byte buffer containing data
'formatted using ICONINFOEX
'WARNING
'Use of this function can result in depletion of available
'User32 and DIBENG.DLL resource memory heaps and Handles for Icons.
'If this happens the operating system will seize up
'so minimize retention of Icon Handles in your calling Program.
'Not recommended for use outside UniPicture
'This is mananged without problem within UniPicture Objects
'***************************************************************
Private Function IconHandleFromDataArr(Bytes() As Byte) As Long
'//Warning - DO NOT Remove - ClassWizMap:512:IconHandleFromDataArr
On Error GoTo ErrorHandler
Dim iInfo As ICONINFOEX
Dim Ret As Long
Dim Buffer() As Byte
Dim LenInfo As Long
Dim newBM As Long

    LenInfo = Len(iInfo)
    If UBound(Bytes) > LenInfo - 1 Then
        upicCopyMemory iInfo, ByVal VarPtr(Bytes(0)), LenInfo
        ReDim Buffer(0 To iInfo.LengthbmMask - 1) As Byte
        upicCopyMemory ByVal VarPtr(Buffer(0)), ByVal VarPtr(Bytes(LenInfo)), iInfo.LengthbmMask
        newBM = BitmapFromDataArr(Buffer())
        Erase Buffer
        If newBM Then
            iInfo.IconInfo.hbmMask = newBM
            ReDim Buffer(0 To UBound(Bytes) - iInfo.LengthbmMask) As Byte
            upicCopyMemory ByVal VarPtr(Buffer(0)), ByVal VarPtr(Bytes(iInfo.LengthbmMask)) + LenInfo, UBound(Bytes()) - iInfo.LengthbmMask - LenInfo
            newBM = BitmapFromDataArr(Buffer())
            Erase Buffer
            If newBM Then
                iInfo.IconInfo.hbmColor = newBM
                IconHandleFromDataArr = upicCreateIconIndirect(iInfo.IconInfo)
            End If
            'Must delete Bitmaps otherwise memory leaks
            If iInfo.IconInfo.hbmMask Then Ret = upicDeleteObject(iInfo.IconInfo.hbmMask)
            If iInfo.IconInfo.hbmColor Then Ret = upicDeleteObject(iInfo.IconInfo.hbmColor)
        End If
    End If
    Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::IconPictureFromDataArr", ""
End Function

'***************************************************************
'Load an Icon into a Byte array
'***************************************************************
Private Function IconToBytes(hIcon As Long, Bytes() As Byte) As Boolean
'//Warning - DO NOT Remove - ClassWizMap:512:IconToBytes
On Error GoTo ErrorHandler
Dim iInfo As ICONINFOEX
Dim Buffer() As Byte
Dim length As Long
Dim Ret As Long, LenInfo As Long
Dim bm As BitMapType

        If hIcon = 0 Then Exit Function
        ReDim Bytes(0 To 0) As Byte
        If m_lngHandle <> 0 Then IuniPicture_ReleaseHandle
        m_lngHeightPixels = 0
        m_lngWidthPixels = 0
        m_lngHeight = 0
        m_lngWidth = 0

        LenInfo = Len(iInfo)
        If upicGetIconInfoByNum(hIcon, ByVal VarPtr(iInfo.IconInfo)) <> 0 Then
            'This is an Icon
            iInfo.PicType = vbPicTypeIcon
            If BitmapToBytes(iInfo.IconInfo.hbmMask, Buffer) Then
                length = UBound(Buffer) + 1
                iInfo.LengthbmMask = length
                ReDim Preserve Bytes(0 To (LenInfo + length - 1)) As Byte
                iInfo.PicType = vbPicTypeIcon
                upicCopyMemory ByVal VarPtr(Bytes(0)), iInfo, LenInfo
                If length > 0 Then
                    upicCopyMemory ByVal VarPtr(Bytes(Len(iInfo))), ByVal VarPtr(Buffer(0)), length
                    Erase Buffer
                    If BitmapToBytes(iInfo.IconInfo.hbmColor, Buffer) Then
                        length = UBound(Buffer) + 1
                        If upicGetObjectAPI(iInfo.IconInfo.hbmColor, Len(bm), bm) <> 0 Then
                            ' Returns zero on error
                            'Width and Height in Pixels
                            m_lngHeightPixels = bm.bm_lngHeight
                            m_lngWidthPixels = bm.bm_lngWidth
                            'Width and Height in HiMetic
                            m_lngWidth = ScaleX(m_lngWidthPixels, False)
                            m_lngHeight = ScaleY(m_lngHeightPixels, False)
                        End If
                        ReDim Preserve Bytes(0 To (LenInfo + iInfo.LengthbmMask + length)) As Byte
                        upicCopyMemory ByVal (VarPtr(Bytes(LenInfo)) + iInfo.LengthbmMask), ByVal VarPtr(Buffer(0)), length
                        IconToBytes = True
                    Else
                        ReDim Bytes(0 To 0) As Byte
                    End If
                End If
            End If
        End If
        'Must destroy icons returned as these are use
        'User32 resources owned by the operating system
        If iInfo.IconInfo.hbmMask Then Ret = upicDeleteObject(iInfo.IconInfo.hbmMask)
        If iInfo.IconInfo.hbmColor Then Ret = upicDeleteObject(iInfo.IconInfo.hbmColor)
        m_blnChanged = True
        Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::IconToBytes", ""
End Function

'*********************************************************************
Private Property Let IuniPicture_BitMap(BitMapHandle As Long)
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_BitMap
On Error GoTo ErrorHandler
    If BitmapToBytes(BitMapHandle, m_DataArr) Then
        Exit Property
    End If
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & ":: BitMap ", ""
End Property

'*********************************************************************
Private Function IuniPicture_BLACKNESS() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_BLACKNESS
End Function

'*********************************************************************
Private Property Let IuniPicture_Changed(Changed As Boolean)
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Changed
    m_blnChanged = Changed
End Property

'*********************************************************************
Private Property Get IuniPicture_Changed() As Boolean
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Changed
    IuniPicture_Changed = m_blnChanged
End Property

'*********************************************************************
Private Function IuniPicture_ClassName() As String
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_ClassName
On Error Resume Next
    'Raise a dummy error
    Err.Raise 9999
    'the ClassName is in Err.Source
    IuniPicture_ClassName = Err.Source & "." & TypeName(Me)
    Err.Clear
End Function

'*********************************************************************
'Clears the Object
'*********************************************************************
Private Sub IuniPicture_Clear()
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Clear
On Error Resume Next
    Clear
End Sub

'*********************************************************************
'Copy Data from one object to another
'It is suggested that once you have completed an Object that you
' optomise this code and eliminate the need to call CopyItemValue
'
'How you do your copyfrom is up to you but obviously if you write
'your own code ClassWiz will not be able to update it if you
'make a change to your Properties
'After you have finalized your code you may want to change Object to
'an Object TypeName for additional speed.
'DO NOT change Object if the CopyFrom Method is an Implemented Interface
'*********************************************************************
Private Sub IuniPicture_CopyFrom(oOriginal As Object, Optional bChanged As Boolean = False)
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_CopyFrom
On Error Resume Next
    CopyFrom oOriginal, bChanged
End Sub

'*********************************************************************
Private Function IuniPicture_DSTINVERT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_DSTINVERT
    IuniPicture_DSTINVERT = &H550009
End Function

'*********************************************************************
'Returns Handle of Bitmap or Icon as the case may be
'0 if error
'*********************************************************************
Private Function IuniPicture_Handle() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Handle
On Error GoTo ErrorHandler
Dim PicType As Long
    If m_lngHandle <> 0 Then
        IuniPicture_Handle = m_lngHandle
        Exit Function
    End If
    If UBound(m_DataArr) < cMin Then Exit Function
    upicCopyMemory PicType, ByVal VarPtr(m_DataArr(0)), 4
    Select Case PicType
        Case vbPicTypeBitmap
            m_lngHandle = BitmapFromDataArr(m_DataArr())
            IuniPicture_Handle = m_lngHandle
            m_blnChanged = True
        Case vbPicTypeIcon
            m_lngHandle = IconHandleFromDataArr(m_DataArr())
            IuniPicture_Handle = m_lngHandle
            m_blnChanged = True
        Case Else
    End Select
    Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & ":: Handle ", ""
End Function

'*********************************************************************
'Height in Hi_Metric 0 for Icons
'*********************************************************************
Private Property Get IuniPicture_Height() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Height
On Error Resume Next
    IuniPicture_Height = m_lngHeight
End Property

'*********************************************************************
'Width of Bitmap or Icon in Pixels
'*********************************************************************
Private Property Get IuniPicture_HeightPixels() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_HeightPixels
On Error Resume Next
    IuniPicture_HeightPixels = m_lngHeightPixels
End Property

'*********************************************************************
'Load Icon data from Icon handle into UniPicture
'*********************************************************************
Private Property Let IuniPicture_Icon(IconHandle As Long)
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Icon
On Error GoTo ErrorHandler
    If IconToBytes(IconHandle, m_DataArr()) Then
        Exit Property
    End If
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & ":: Icon ", ""
End Property

'*********************************************************************
'Load a Bitmap into UniPicture from a device context hDC
'width/height in Pixels
'returns true if Bitmap loaded
'*********************************************************************
Private Function IuniPicture_LoadBitmap(hdc As Long, WidthPixels As Long, HeightPixels As Long) As Boolean
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_LoadBitmap
On Error GoTo ErrorHandler
Dim bm As BitMapType
Dim newBM As Long
Dim DestDC&
Dim oldbmdest&
   
        bm.bmBits = 0
        bm.bm_lngHeight = HeightPixels
        bm.bm_lngWidth = WidthPixels
        'Get device context - set up source
        DestDC = upicCreateCompatibleDC(0)
        If DestDC <> 0 Then
            newBM = upicCreateCompatibleBitmap(hdc, bm.bm_lngWidth, bm.bm_lngHeight)
            If newBM Then
                'Now do the copy
                oldbmdest = upicSelectObject(DestDC, newBM)
                If oldbmdest <> 0 Then
                    Call upicBitBlt(DestDC, 0, 0, bm.bm_lngWidth, bm.bm_lngHeight, hdc, 0, 0, IuniPicture_SRCCOPY)
                    IuniPicture_BitMap = newBM
                    Call upicSelectObject(DestDC, oldbmdest)
                End If
                Call upicDeleteObject(newBM)
                IuniPicture_LoadBitmap = True
            End If
            'Clean up the device contexts
            Call upicDeleteDC(DestDC)
        End If
        m_blnChanged = True
        Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::LoadBitmap", ""
End Function

'*********************************************************************
Private Function IuniPicture_MERGECOPY() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_MERGECOPY
    IuniPicture_MERGECOPY = &HC000CA
End Function


'*********************************************************************
Private Function IuniPicture_MERGEPAINT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_MERGEPAINT
    IuniPicture_MERGEPAINT = &HBB0226
End Function

'*********************************************************************
Private Function IuniPicture_NOTSRCCOPY() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_NOTSRCCOPY
    IuniPicture_NOTSRCCOPY = &H330008
End Function

'*********************************************************************
Private Function IuniPicture_NOTSRCERASE() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_NOTSRCERASE
    IuniPicture_NOTSRCERASE = &H1100A6
End Function

'*********************************************************************
Private Function IuniPicture_Object() As Object
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Object
    Set IuniPicture_Object = Me
End Function

'*********************************************************************
Private Function IuniPicture_PATCOPY() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_PATCOPY
    IuniPicture_PATCOPY = &HF00021
End Function

'*********************************************************************
Private Function IuniPicture_PATINVERT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_PATINVERT
    IuniPicture_PATINVERT = &H5A0049
End Function

'*********************************************************************
Private Function IuniPicture_PATPAINT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_PATPAINT
    IuniPicture_PATPAINT = &HFB0A09
End Function

'*********************************************************************
'Loads UniPicture with data in a stdPicture
'*********************************************************************
Private Property Set IuniPicture_Picture(Picture As StdPicture)
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Picture
On Error Resume Next
    If Picture Is Nothing Then
        IuniPicture_Clear
    Else
        Select Case Picture.Type
    '***********************************************************
        Case vbPicTypeBitmap
            If Not BitmapToBytes(Picture.Handle, m_DataArr) Then Error 1000
    '***********************************************************
        Case vbPicTypeIcon
            If Not IconToBytes(Picture.Handle, m_DataArr) Then Error 1000
    '***********************************************************
        Case vbPicTypeEMetafile
            Error 1000
    '***********************************************************
        Case vbPicTypeMetafile
            Error 1000
    '***********************************************************
        Case Else 'vbPicTypeNone
            Error 1000
    '***********************************************************
        End Select
    End If
    Exit Property
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::Picture", ""
End Property

'*********************************************************************
'Retrieves a stdPicture from the data in UniPicture
'*********************************************************************
Private Property Get IuniPicture_Picture() As StdPicture
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Picture
On Error GoTo ErrorHandler
    IuniPicture_PictureFn IuniPicture_Picture
    Exit Property
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::Picture", ""
End Property

'*********************************************************************
'Retrieves a stdPicture from the data in UniPicture
'returns True on success
'*********************************************************************
Private Function IuniPicture_PictureFn(Picture As IPictureDisp) As Boolean
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Picture
On Error GoTo ErrorHandler
Dim hHandle As Long
Dim PicType As Long
Dim Ret As Long

    IuniPicture_PictureFn = False
    If UBound(m_DataArr) - 1 < 8 Then Exit Function
    upicCopyMemory PicType, ByVal VarPtr(m_DataArr(0)), 4

    Select Case PicType
        Case vbPicTypeBitmap
            hHandle = BitmapFromDataArr(m_DataArr())
            If hHandle Then
                If CreatePictureFromBitmap(hHandle, 0, Picture) Then
                    IuniPicture_PictureFn = True
                End If
                Call upicDeleteObject(hHandle)
            End If

        Case vbPicTypeIcon
            hHandle = IconHandleFromDataArr(m_DataArr())
            If hHandle <> 0 Then
                If CreatePictureFromhIcon(hHandle, 0, Picture) Then
                    IuniPicture_PictureFn = True
                End If
                Call upicDestroyIcon(hHandle)
            End If

        Case vbPicTypeEMetafile
            Exit Function
        Case vbPicTypeMetafile
            Exit Function
        Case Else 'vbPicTypeNone
            Set Picture = New StdPicture
            IuniPicture_PictureFn = True
        End Select
        Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::PictureFn", ""
End Function

'*********************************************************************
'Returns Picture type held by UniPicture
'*********************************************************************
Private Function IuniPicture_PicType() As PictureTypeConstants
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_PicType
On Error GoTo ErrorHandler
Dim bmInfoEX As BitmapINFOEX
Dim lPicType As Long
        If UBound(m_DataArr) - 1 > cMin Then
            upicCopyMemory lPicType, ByVal VarPtr(m_DataArr(0)), 4
            IuniPicture_PicType = lPicType
            Exit Function
        End If
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::PictureType", ""
End Function

'*********************************************************************
'Release a Handle returned by a call to Function Handle
'saves the need to remember whether the handle is for a
'Bitmap or Icon
'*********************************************************************
Private Function IuniPicture_ReleaseHandle() As Boolean
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_ReleaseHandle
Dim PicType As Long
    If m_lngHandle <> 0 Then
        If UBound(m_DataArr) - 1 < cMin Then Exit Function
        upicCopyMemory PicType, ByVal VarPtr(m_DataArr(0)), 4
        Select Case PicType
            Case vbPicTypeBitmap
                Call upicDeleteObject(m_lngHandle)
            Case vbPicTypeIcon
                Call upicDestroyIcon(m_lngHandle)
            Case Else
                Exit Function
        End Select
        m_lngHandle = 0
        m_blnChanged = True
        IuniPicture_ReleaseHandle = True
    End If
    Exit Function
ErrorHandler:
    RaiseError 28502, IuniPicture_ClassName & "::ReleaseHandle", ""
End Function

'*********************************************************************
'Draw the Bitmap or Icon held by UniPicture onto a supplied device context
'X and Y in Pixels
'Return True is successfull..False otherwise
'If PictureType is Icon
'   If nWidthPixels > 0 then renders Icon at size
'       nWidthPixels and nHeightPixels
'   Else
'       use original size
'*********************************************************************
Private Function IuniPicture_Render(hdc As Long, ByVal X As Long, ByVal Y As Long, Optional ByVal WidthPixels As Long, Optional ByVal HeightPixels As Long, Optional ByVal xSrc As Long, Optional ByVal ySrc As Long, Optional ByVal cxSrc As Long, Optional ByVal cySrc As Long, Optional ByVal dwRop As Long) As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Render
On Error GoTo ErrorHandler
Dim srcDC As Long
Dim oldDC As Long
Dim Ret As Long
Dim PicType As Long
Dim hHandle As Long

    If hdc = 0 Then Exit Function
    If m_lngWidthPixels <= 0 Or m_lngHeightPixels <= 0 Then Exit Function
    If UBound(m_DataArr) - 1 < cMin Then Exit Function
    'can only select Bitmap into one DC at a time
    If m_lngHandle <> 0 Then Exit Function

    IuniPicture_Render = True
    upicCopyMemory PicType, ByVal VarPtr(m_DataArr(0)), 4
    Select Case PicType
        Case vbPicTypeBitmap
            hHandle = BitmapFromDataArr(m_DataArr())
            If hHandle = 0 Then Exit Function
            If dwRop = 0 Then dwRop = IuniPicture_SRCCOPY
            If cxSrc = 0 Then cxSrc = m_lngWidthPixels
            If cySrc = 0 Then cySrc = m_lngHeightPixels
            If WidthPixels = 0 Then WidthPixels = m_lngWidthPixels
            If HeightPixels = 0 Then HeightPixels = m_lngHeightPixels
            'Paint BitMap on hDC
            If hHandle <> 0 Then
                RenderBM hHandle, hdc, X, Y, WidthPixels, HeightPixels, xSrc, ySrc, cxSrc, cySrc, dwRop
                'Delete resource hHandle
                Call upicDeleteObject(hHandle)
            End If

        Case vbPicTypeIcon
            If m_lngHandle <> 0 Then
                IuniPicture_Render = upicDrawIcon(hdc, X, Y, m_lngHandle)
            Else
                If WidthPixels = 0 Then
                    hHandle = IconHandleFromDataArr(m_DataArr())
                    If hHandle <> 0 Then
                        IuniPicture_Render = upicDrawIcon(hdc, X, Y, hHandle)
                        'Destroy resource hHandle
                        Call upicDestroyIcon(hHandle)
                    End If
                Else
                    If cxSrc = 0 Then cxSrc = m_lngWidthPixels
                    If cySrc = 0 Then cySrc = m_lngHeightPixels
                    If WidthPixels = 0 Then WidthPixels = m_lngWidthPixels
                    If HeightPixels = 0 Then HeightPixels = m_lngHeightPixels
                    'Paint Mask on hDC
                    hHandle = BMMaskHandleFromIconDataArr(m_DataArr)
                    If hHandle <> 0 Then
                        RenderBM hHandle, hdc, X, Y, WidthPixels, HeightPixels, xSrc, ySrc, cxSrc, cySrc, IuniPicture_SRCAND
                        'Delete resource hHandle
                        Call upicDeleteObject(hHandle)
                    End If
                    'Paint BitMap on hDC
                    hHandle = BMHandleFromIconDataArr(m_DataArr)
                    If hHandle <> 0 Then
                        Call RenderBM(hHandle, hdc, X, Y, WidthPixels, HeightPixels, xSrc, ySrc, cxSrc, cySrc, IuniPicture_SRCPAINT)
                        'Delete resource hHandle
                        Call upicDeleteObject(hHandle)
                    End If
                End If
            End If
        Case Else
            IuniPicture_Render = 0
    End Select
    Exit Function
ErrorHandler:
    IuniPicture_Render = 0
    RaiseError 28502, IuniPicture_ClassName & "::Render", ""
End Function

'*********************************************************************
Private Function IuniPicture_SRCAND() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_SRCAND
    IuniPicture_SRCAND = &H8800C6
End Function

'*********************************************************************
Private Function IuniPicture_SRCCOPY() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_SRCCOPY
    IuniPicture_SRCCOPY = &HCC0020 'destination memory = source memory
End Function

'*********************************************************************
Private Function IuniPicture_SRCERASE() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_SRCERASE
    IuniPicture_SRCERASE = &H440328
End Function

'*********************************************************************
Private Function IuniPicture_SRCINVERT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_SRCINVERT
    IuniPicture_SRCINVERT = &H660046
End Function

'*********************************************************************
Private Function IuniPicture_SRCPAINT() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_SRCPAINT
    IuniPicture_SRCPAINT = &HEE0086
End Function

'*********************************************************************
Private Function IuniPicture_WHITENESS() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_WHITENESS
    IuniPicture_WHITENESS = &HFF0062
End Function

'*********************************************************************
'Width of Bitmap in Hi_Metric 0 for Icons
'*********************************************************************
Private Property Get IuniPicture_Width() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_Width
On Error Resume Next
    IuniPicture_Width = m_lngWidth
End Property

'*********************************************************************
'Width of Bitmap or Icon in Pixels
'*********************************************************************
Private Property Get IuniPicture_WidthPixels() As Long
'//Warning - DO NOT Remove - ClassWizMap:1027:IuniPicture_WidthPixels
On Error Resume Next
    IuniPicture_WidthPixels = m_lngWidthPixels
End Property


'*********************************************************************
'     Private Sub RaiseError(ByVal errNum As Long, Procedure As String, Optional ErrMsg As String)
'     Centralised Error Handler used by various classes/modules
'     Always included when class first written
'*********************************************************************
Private Sub RaiseError(ByVal errNum As Long, Procedure As String, Optional ErrMsg As String)
'//Warning - DO NOT Remove - ClassWizMap:512:RaiseError
    If IsMissing(ErrMsg) Then
        Err.Raise vbObjectError + errNum, ClassName & "::" & Procedure$
    Else
        Err.Raise vbObjectError + errNum, ClassName & "::" & Procedure$, ErrMsg
    End If
End Sub

'***************************************************************
'Render a BitMap to a Devixe Context
'Called by IuniPicture_Render
'***************************************************************
Private Function RenderBM(hHandle As Long, hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidthPixels As Long, ByVal nHeightPixels As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal cxSrc As Long, ByVal cySrc As Long, ByVal dwRop As Long) As Long
'//Warning - DO NOT Remove - ClassWizMap:512:RenderBM
On Error GoTo ErrorHandler
Dim srcDC As Long
Dim oldDC As Long
Dim Ret As Long
Dim PicType As Long

    If hdc = 0 Then Exit Function
    If hHandle = 0 Then Exit Function
    If UBound(m_DataArr) - 1 < cMin Then Exit Function

    'Get device context - set up source
    srcDC = upicCreateCompatibleDC(0)
    If srcDC <> 0 Then
        oldDC = upicSelectObject(srcDC, hHandle)
        If oldDC <> 0 Then
            'Now do the copy
            Ret = upicStretchBlt(hdc, X, Y, nWidthPixels, nHeightPixels, srcDC, xSrc, ySrc, cxSrc, cySrc, dwRop)
            'Clean up the device contexts
            Call upicSelectObject(srcDC, oldDC)
        End If
        Call upicDeleteDC(srcDC)
    End If

ErrorHandler:
End Function

'***************************************************************
'Convert Pixels to HiMetric and visa versa
'True  - convert from  HiMetric to Pixels
'False - convert from  Pixels to HiMetric
'***************************************************************
Private Function ScaleX(ByVal dbl As Double, Action As Boolean) As Double
'//Warning - DO NOT Remove - ClassWizMap:512:ScaleX
Dim X As Long
Dim dblValue As Double
    dblValue = (14.4 / 25.4)
    X = Screen.TwipsPerPixelX
    If Action Then 'To Pixels
        ScaleX = (dbl * dblValue) \ X
    Else 'To HiMetric
        ScaleX = CLng((dbl / dblValue) * X)
    End If
End Function

'***************************************************************
'Convert Pixels to HiMetric and visa versa
'True  - convert from  HiMetric to Pixels
'False - convert from  Pixels to HiMetric
'***************************************************************
Private Function ScaleY(ByVal dbl As Double, Action As Boolean) As Double
'//Warning - DO NOT Remove - ClassWizMap:512:ScaleY
'//Warning - DO NOT Remove - ClassWizMap:514:StdProperty
Dim Y As Long
Dim dblValue As Double
    Y = Screen.TwipsPerPixelY
    dblValue = (14.4 / 25.4)
    If Action Then 'To Pixels
        ScaleY = (dbl * dblValue) \ Y
    Else 'To HiMetric
        ScaleY = CLng((dbl / dblValue) * Y)
    End If
End Function

'*****************************************************************
'General Method used by ClassWiz Code to zero Variants
'*****************************************************************
Private Sub VariantNull(vValue As Variant)
'//Warning - DO NOT Remove - ClassWizMap:512:VariantNull
    If IsObject(vValue) Then
        Set vValue = Nothing
    ElseIf VarType(vValue) = vbString Then
        vValue = vbNullString
    Else
        vValue = 0
    End If
End Sub


''**********************************************************
'CLASSWIZ5/6
''**********************************************************
'ClassWiz5 can be used as a drop-in replacement for the ClassBuilder Add-In supplied with Visual Basic
'
'Use Visual Basic 5/6 Source Code Generator to Increase productivity and maintain code consistency and uniformity by creating your own self editing Code Objects for Classes, Modules, Forms and UserControls.
'
'ClassWiz5 is a Visual Basic 5/6 Add-In UTILITY which Generates full ready to use Visual Basic Source Code for the organisation, management and manipulation of Data and Objects, including Persistence to disk and generation of Interfaces.
'
'FULL SOURCE CODE for the ClassWizCode ActiveX  and also the standard ClassWiz5 Code Objects for generating/editing Component Code is supplied with the Standard Version of ClassWiz5.( provided at )no additional charge.
'
'You can Add, Delete and Edit Properties,  Methods, Events, Enums, Udts and Implemented Interfaces in ClassModules(.cls) and also in Forms (.frm), UserControls  (.ctl) and Standard Modules (.bas) from within the Visual Basic 5 or 6 Visual Basic Integrated Design Enviroment.
'
'Automatically writes standard code to read/write data to and from the Visual Basic PropertyBag object in VB6 or CWPropertyBag in VB5 Projects. No more labouring over the code for this operation.
'
'Persist data for Private objects such as Forms and Private Classes using the ICWPropertyBag Interface.
'
'Automatically write delegated code for implemented interfaces. No more manual work cutting and pasting interface code. Add and Remove all Interface Members by a single click of the mouse from within ClassWiz5. Edit an Interface Member and automatically update the Member in all Components which Implements the Interface.
'
'ClassWiz5 can Create and Edit fully operational Classes, Collections, PropertyBags, Keyed Lists, Lists, Queues/Stacks,  HashTables,  Component Interfaces and any other Code Object you desire.
'
'ClassWiz5  allows you to update or change the operation of the Code generation to meet your specific requirements. (eg. add you specific Prefixes to Data Members ie m_str.)
'
'ClassWiz5 can generate Class Components based on Code you provide in ClassWizCode ActiveX or you can just use the standard Code generated by ClassWiz5.
'
'The List based objects provided can be used to replace Standard Visual Basic Collections and Dictionary Objects and also single and multi-dimensional arrays.
'
'Please Print the file Manual.rtf, examine the source code provided and try the demonstration version of ClassWiz5 to see how it can help you in your programming of Visual Basic Code.
'
'The concept for ClassWiz5 was developed by Brian Douglas Parkinson  to overcome the need for repetitive coding of Visual Basic Code, particularly for storing data in Collecions and KeyedLists, copying object data from one object to another and writing data to PropertyBag Objects.
'
'Download a copy of the fully operational ClassWiz5 demonstration from
'
'http://www.iceminster.com/CWDemo.zip (6.5MB) or the Manual for ClassWiz 5 from

'http://www.iceminster.com/Manual.zip
'
'Brian is contactable at Email:      Brian@iceminster.com
'
'ClassWiz5  is Copyright  1999 Brian D. Parkinson(brian@iceminster.com). All rights reserved.
'
'

'*********************************************************************
'Add your Component Initialization information here
'*********************************************************************
Private Sub Class_InitProperties()
'//Warning - DO NOT Remove - ClassWizMap:1027:Class_InitProperties
'-------------------------------------------------------------------------------------
'User Code follows
'-------------------------------------------------------------------------------------
'PlaceHolder
End Sub

'**********************************************************
'Once you have completed your code for this Object it is
'suggested that you examine what can be done to further
'optimise the code for reading Data to the Object from
'the XXPropertyBag .. delete any unnecessary code
'**********************************************************
'ClassWiz assumes Objects Implement the ICWPropertyBag Interface
'This permits common code for Private and Public Components you write
'If you reference an Intrinsic Object (ie. Control) you should relocate
'Code for PropertyBag Operations outside of the Mapping
'You may also need to modify Object Creation Code to your requirements
'**********************************************************

Private Sub Class_ReadProperties(PropBag As PropertyBag)
'//Warning - DO NOT Remove - ClassWizMap:1027:Class_ReadProperties
On Error Resume Next
'**********************************************************
'Add Your Specific Code Here to write to PropertyBag Object
'Alternatively Implement ICWPropertyBag in your Objects
'CWPropertyBag handles private objects and arrays
'**********************************************************
'''    ICWPropertyBag_ReadProperties PropBag
'**********************************************************
'Add Your Specific Code Here to read from PropertyBag Object
'This is the type of code required to access a Private Object in the Project.
'The Private Object must Implement the ICWPropertyBag Interface
'Set PrivateObject = New xxxx
'CWReadContents PropBag, "CW" & nCount, PrivateObject, Nothing

'**********************************************************

End Sub

'**********************************************************
'Once you have completed your code for this Object it is
'suggested that you examine what can be done to further
'optimise the code for writing Data from the Object to
'the PropertyBag .. delete any unnecessary code
'**********************************************************
'ClassWiz assumes Objects Implement the ICWPropertyBag Interface
'This permits common code for Private and Public Components you write
'If you reference an Intrinsic Object (ie. Control) you should relocate
'Code for PropertyBag Operations outside of the Mapping
'**********************************************************

Private Sub Class_WriteProperties(PropBag As PropertyBag)
'//Warning - DO NOT Remove - ClassWizMap:1027:Class_WriteProperties
On Error Resume Next

'**********************************************************
'Add Your Specific Code Here to write to PropertyBag Object
'Alternatively Implement ICWPropertyBag in your Objects
'CWPropertyBag handles private objects and arrays
'**********************************************************
'''    ICWPropertyBag_WriteProperties PropBag

'**********************************************************
'Add Your Specific Code Here to write to PropertyBag Object

'This is the type of code required to access a Private Object in the Project.
'The Private Object must Implement the ICWPropertyBag Interface
    'CWWriteContents PropBag, "CW" & nCount + 1, PrivateObject, Nothing

'**********************************************************

End Sub

Private Function ICWPropertyBag_ClassName() As String
'//Warning - DO NOT Remove - ClassWizMap:1027:ICWPropertyBag_ClassName
ICWPropertyBag_ClassName = ClassName
End Function

'*********************************************************************
'Add your Component Initialization information here
'*********************************************************************
Private Sub ICWPropertyBag_InitProperties(Optional vData As Variant)
'//Warning - DO NOT Remove - ClassWizMap:1027:ICWPropertyBag_InitProperties
'-------------------------------------------------------------------------------------
'User Code follows
'-------------------------------------------------------------------------------------
'PlaceHolder
End Sub

Private Function ICWPropertyBag_ParentObject() As Object
'//Warning - DO NOT Remove - ClassWizMap:1027:ICWPropertyBag_ParentObject
On Error Resume Next
    Set ICWPropertyBag_ParentObject = Me
End Function

'**********************************************************
'Once you have completed your code for this Object it is
'suggested that you examine what can be done to further
'optimise the code for reading Data to the Object from
'the XXPropertyBag .. delete any unnecessary code
'**********************************************************
'ClassWiz assumes Objects Implement the ICWPropertyBag Interface
'This permits common code for Private and Public Components you write
'If you reference an Intrinsic Object (ie. Control) you should relocate
'Code for PropertyBag Operations outside of the Mapping
'You may also need to modify Object Creation Code to your requirements
'**********************************************************
'Once a the Sorted Property of the CWPropertyBag has been set to False
'it cannot be changed and each Read Operation is sequential
'starting at Index = 1 and proceeding to Count then back to 1
'Note: Mixing access using PropertyName and sequential Indexing
'in the same object will lead to problems.
'Choose only one method for Read/Write operation for each object
'**********************************************************

'''Private Sub ICWPropertyBag_ReadProperties(oPropBag As Object, Optional vData As Variant)
''''//Warning - DO NOT Remove - ClassWizMap:1027:ICWPropertyBag_ReadProperties
'''On Error Resume Next
'''Dim sPropName As String
'''    sPropName = "UniPicture"
'''    If Not IsMissing(vData) Then
'''        If VarType(vData) = vbString Then sPropName = vData
'''    End If
'''
'''    If StrComp(TypeName(oPropBag), "PropertyBag", vbTextCompare) = 0 Then
'''        Dim VBPropBag As PropertyBag
'''        Dim pb As New CWPropertyBag
'''        Set VBPropBag = oPropBag
'''        pb.Contents = CWArrayFromBytes(VBPropBag.ReadProperty(sPropName))
'''        Call ICWPropertyBag_ReadProperties(pb)
'''        Exit Sub
'''    Else
'''        If StrComp(TypeName(oPropBag), "CWPropertyBag", vbTextCompare) <> 0 Then
'''            Exit Sub
'''        End If
'''    End If
'''
'''Dim PropBag As CWPropertyBag
'''    Set PropBag = oPropBag
''''Use the Key as the PropertyName
''''//Warning - DO NOT Remove - ClassWiz CWPropBagReadPropStart
'''    'Read Class Property Data
''''//Warning - DO NOT Remove - ClassWiz CWPropBagReadPropEnd
'''
'''    m_lngHeight = PropBag.ReadProperty("Height", 0)
'''    m_lngWidth = PropBag.ReadProperty("Width", 0)
'''    m_lngHeightPixels = PropBag.ReadProperty("HeightPixels", 0)
'''    m_lngWidthPixels = PropBag.ReadProperty("WidthPixels", 0)
''''-------------------------------------------------------------------------------
''''Used to store BitMap and Icon data
'''     m_DataArr = PropBag.ReadProperty("Data", Empty)
'''
''''**********************************************************
''''Add Your Specific Code Here to write to PropertyBag Object
'''
''''Include Private Object as the Default Value so it may be accessed using
''''the ICWPropertyBag Interface.. you must to manage the Index
''''here and in ICWPropertyBag_WriteProperties.
''''ClassWiz cannot not Manage your private Objects as it has Knowledge of them.
''''If you have created a Property for the Private Object using ClassWiz you
''''should change its MappingCode to 1 so ClassWiz will not include it when
''''Updating Block Data Mapping
'''    'If PropBag.PropIsObject(nCount) Then
'''        'Set DataObj = PropBag.ReadProperty("PropertyName", DataObj)
'''    'End If
''''**********************************************************
'''
'''End Sub
'''
''''**********************************************************
''''Once you have completed your code for this Object it is
''''suggested that you examine what can be done to further
''''optimise the code for writing Data from the Object to
''''the PropertyBag .. delete any unnecessary code
''''**********************************************************
''''ClassWiz assumes Objects Implement the ICWPropertyBag Interface
''''This permits common code for Private and Public Components you write
''''If you reference an Intrinsic Object (ie. Control) you should relocate
''''Code for PropertyBag Operations outside of the Mapping
''''**********************************************************
''''Once a the Sorted Property of the CWPropertyBag has been set to False
''''it cannot be changed and each Read Operation is sequential
''''starting at Index = 1 and proceeding to Count then back to 1
''''Note: Mixing access using PropertyName and sequential Indexing
''''in the same object will lead to problems.
''''Choose only one method for Read/Write operation for each object
''''**********************************************************
'''
'''Private Sub ICWPropertyBag_WriteProperties(oPropBag As Object, Optional vData As Variant)
''''//Warning - DO NOT Remove - ClassWizMap:1027:ICWPropertyBag_WriteProperties
'''On Error Resume Next
'''Dim sPropName As String
'''    sPropName = "UniPicture"
'''    If Not IsMissing(vData) Then
'''        If VarType(vData) = vbString Then sPropName = vData
'''    End If
'''    If StrComp(TypeName(oPropBag), "PropertyBag", vbTextCompare) = 0 Then
'''        Dim VBPropBag As PropertyBag
'''        Dim pb As New CWPropertyBag
'''        Set VBPropBag = oPropBag
'''        Call ICWPropertyBag_WriteProperties(pb)
'''        Call VBPropBag.WriteProperty(sPropName, CWArrayToBytes(pb.Contents))
'''        Exit Sub
'''    Else
'''        If StrComp(TypeName(oPropBag), "CWPropertyBag", vbTextCompare) <> 0 Then
'''            Exit Sub
'''        End If
'''    End If
'''
'''Dim PropBag As CWPropertyBag
'''    Set PropBag = oPropBag
''''Use the Key as the PropertyName
''''//Warning - DO NOT Remove - ClassWiz CWPropBagWritePropStart
'''
''''Write Class/Std Property Data to PropertyBag
''''//Warning - DO NOT Remove - ClassWiz CWPropBagWritePropEnd
'''
'''    PropBag.WriteProperty "Height", m_lngHeight, 0
'''    PropBag.WriteProperty "Width", m_lngWidth, 0
'''    PropBag.WriteProperty "HeightPixels", m_lngHeightPixels, 0
'''    PropBag.WriteProperty "WidthPixels", m_lngWidthPixels, 0
''''-------------------------------------------------------------------------------
''''Used to store BitMap and Icon data
'''    PropBag.WriteProperty "Data", m_DataArr, Empty
''''**********************************************************
''''Add Your Specific Code Here to write to PropertyBag Object
'''
''''Include Private Object as the Default Value so it may be accessed using
''''the ICWPropertyBag Interface.. you must to manage the Index
''''here and in ICWPropertyBag_ReadProperties.
''''ClassWiz cannot not Manage your private Objects as it has Knowledge of them.
''''If you have created a Property for the Private Object using ClassWiz you
''''should change its MappingCode to 1 so ClassWiz will not include it when
''''Updating Block Data Mapping.
'''        'PropBag.WriteProperty "PropertyName", DataObj, Empty
''''**********************************************************
'''
'''End Sub
